#include "papu_internals.hh"
#include "papu_decayunit.hh"

void decayunit::write(fBYTE ind, fBYTE value)
{
    if(ind == 0)
    {
        decayrate = value & 15;
        decaymode = (value>>4) & 3;
        #if PAPU_DECAY_DEBUG
        if(decaymode & 1)
        	fprintf(stderr, "[\33[0;1;34mvolume=%u\33[m]", decayrate);
        else if(decaymode & 2)
        	fprintf(stderr, "[\33[0;36mdrate=%u,looping\33[m]", decayrate);
        else
        	fprintf(stderr, "[\33[0;36mdrate=%u\33[m]", decayrate);
    	#endif
    }
    else if(ind == 3)
    {
        #if PAPU_DECAY_DEBUG
    	fprintf(stderr, "[\33[0;1;34mdcounter=15,was %u\33[m]", decaycounter);
    	#endif
    	
    	/* Only a write out to $4003/$4007/$400F will reset the
         * current envelope decay counter to a known state (to
         * $F, the maximum volume level) for the appropriate
         * channel's envelope decay hardware.
         */
    	decaycounter = 15;
    }
    // Decay rate is the speed it changes with.
}

BEGIN_HZTICKER(240, decayunit)
    if(!decaypos)
    {
        // This counter is for timing; it always runs.
        decaypos = decayrate;                
        
        if(decaycounter > 0)
            --decaycounter;
        else if(decaymode & 2)
            decaycounter = 15;
    }
    else
        --decaypos;
END_HZTICKER
