#ifndef bisqpAPU_decayunit
#define bisqpAPU_decayunit
class decayunit
{
    fBYTE decaycounter;
    fBYTE decayrate;
    fBYTE decaypos;
    fBYTE decaymode;
public:
    decayunit() : decaycounter(0), decayrate(15), decaypos(0), decaymode(0x10)
    {
    }
    
    void write(fBYTE ind, fBYTE value);
    
    inline unsigned getvol() const
    {
    	if(decaymode & 1)
    	{
    		/* When the envelope decay bit (bit 4) is set(1), the
    		 * current volume value (bits 0-3) is sent directly to
    		 * the channel DAC.
    		 */
    		return decayrate; 
    	}
    	
    	/* When the envelope decay disable bit is cleared, bits 0-3
    	 * now control the envelope decay rate, and an internal 4-bit
    	 * down counter (hereon the envelope decay counter) now
    	 * controls the channel's volume level.
    	 */    	
        return decaycounter;
    }
    DEFINE_HZTICKER(240);

    void debug_silence()
    {
        if(decaymode & 1)
        	fprintf(stderr, ";volume=%u", decayrate);
        else
        {
        	fprintf(stderr, ";decay[%u,rate=%u", decaycounter, decayrate);
        	if(decaymode & 2)
	        	fprintf(stderr, ",looping");
	    }
    }
};
#endif
