#include "sizes.h"
#include "clock.h"

template<class T>
class papuhzticker : public T
{
private:
    unsigned countermax, hzcounter;
    fBYTE hzpos;
public:
    papuhzticker() : hzpos(0)
    {
        countermax = 1364 * Clock->ScanlineCount / 4;
        // This makes 240 ticks per second
        hzcounter = countermax;
    }
    void hzticks();
    void tick()
    {
        if(!--hzcounter)
        {
            hzcounter = countermax;
            hzticks();
        }
        T::tick();
    }
};
