#include "papu_internals.hh"
#include "papu_triangleunit.hh"

void triangleunit::write(fBYTE ind, fBYTE value)
{
	#if PAPU_TRIANGLE_DEBUG
    fprintf(stderr, "triangle.write(%u, 0x%02X) -", ind, value);
    #endif
    waveunit::write(ind, value);
    lengthunit::write(ind, value);
    
    if(ind == 3)
    {
        trimode = (oldbit || !linearcounter) ? triload : tricount;            
    }
    else if(ind == 0)
    {
        triloadvalue = value & 0x7F;
        bool newbit = value & 0x80;
        
        if(!oldbit)
        {
            trimode = tricount;
            linearcounter = triloadvalue;
        }
        else if(!newbit && !linearcounter)
            trimode = tricount;
        
        newbit = oldbit;
    }
    jammed = !linearcounter || getwavelen() < 8;
    #if PAPU_TRIANGLE_DEBUG
    if(jammed)
        fprintf(stderr, "-> jammed\n");
    else if(lengthunit_silent())
        fprintf(stderr, "-> silent\n");
    else
        fprintf(stderr, "-> ok\n");
    #endif
}

BEGIN_HZTICKER(240, triangleunit)
    if(trimode==tricount && linearcounter > 0)
    {
        --linearcounter;
        if(!linearcounter)jammed = true;
    }
END_HZTICKER
